//
//		Color Picker  Copyright(C)1996. Masakazu Fujimiya	
//		m-fujimiya@nri.co.jp
//

import java.awt.*;

public class colorpicker extends java.applet.Applet {
	Color	fColor;
	int	cx,cy,cw,ch;
	int	xsep,ysep;
	int	px,py,sy;
	int	satx,saty,satw,sath;
	int	mainx,mainy,mainw,mainh;
	double	hValue,sValue,bValue;
	int	pox[],poy[];
	Image	offs;		// Offscreen image
	Graphics	grf;	// Offscreen graph port
	
	public void init() {
		pox = new int[4];
		poy = new int[4];
		
		// Off screen bitmap image
		offs = createImage(size().width, size().height);
        	grf  = offs.getGraphics();

		cx = cy = 10;
		cw = 4    ; ch = 8;
		xsep = 64 ; ysep = 16;
		hValue = 0; sValue = 0; bValue = 1;
		
		satx = xsep*cw + cx*2;
		satw = cx*2;
		saty = cy;
		sath = ysep*ch;
		sy = saty + sath;
		mainx = px = cx;
		mainy = py = cy;
		mainw = xsep*cw;
		mainh = ysep*ch;
	}
	
	
	public void paint(Graphics g) {
		int	i,j;
		int	ix,iy;
		int	col;
		float	h,s,b;
		
		grf.setColor(Color.lightGray);
		grf.fillRect(0, 0, size().width, size().height);
		for (i=0 ; i<xsep ; i++) {
			for (j=0 ; j<ysep ; j++) {
				ix = i*cw + cx;
				iy = j*ch + cy;
				h = (float)((double)i/(double)xsep);
				s = (float)((double)j/(double)ysep);
				b = (float)bValue;
				col = Color.HSBtoRGB(h,s,b);
				grf.setColor(new java.awt.Color(col));
				grf. fillRect(ix,iy,cw,ch);
			}
		}
		g.drawImage(offs, 0, 0, this);
		paintAns(g);
		
		g.setColor(Color.lightGray);
		g.draw3DRect(satx-1, saty-1, satw+1, sath+1, true);
		g.draw3DRect(mainx-1, mainy-1, mainw+1, mainh+1, true);
	}
	
	
	public void paintAns(Graphics g) {
		float	h,s,b;
		int	col;
		int	ix,iy,i,j;
		
		for (j=0 ; j<ysep ; j++) {
			ix = xsep*cw + cx + cx;
			iy = j*ch + cy;
			h = (float)hValue;
			s = (float)sValue;
			b = (float)((double)j/(double)ysep);
			col = Color.HSBtoRGB(h,s,b);
			g.setColor(new java.awt.Color(col));
			g. fillRect(ix,iy,cx*2,ch);
		}
		
		ix = (int)(hValue*(double)cw*(double)xsep) + cx;
		iy = (int)(sValue*(double)ch*(double)ysep) + cy;
		g.setColor(Color.yellow);
		g.drawRect(ix-1,iy-1,2,2);
		g.setColor(Color.blue);
		g.drawRect(ix-2,iy-2,4,4);
		
		pox[0] = pox[3] = xsep*cw + cx*3;
		poy[0] = poy[3] = (int)(bValue*(double)ysep*(double)ch) + cy;
		pox[1] = pox[2] = pox[0] + 4;
		poy[1] = poy[0] + 4;
		poy[2] = poy[0] - 4;
		g.setColor(Color.yellow);
		g.fillPolygon(pox, poy, 3);
		g.setColor(Color.blue);
		g.drawPolygon(pox, poy, 4);
		paintValue(g);
	}
	
	
	public void paintValue(Graphics g) {
		float	h,s,b;
		int	col;
		String	wks,outs;
		int	red,green,blue;
		
		h = (float)hValue;
		s = (float)sValue;
		b = (float)bValue;
		col = Color.HSBtoRGB(h,s,b);
		g.setColor(new java.awt.Color(col));
		g. fill3DRect(mainx, mainy+mainh+cy, mainw+cx+satw,cy*2, true);
		
		int wk = col/256/256/256;
		col = col - wk;
		red = col/256/256;
		green = (col-red*256*256)/256;
		blue = col-red*256*256-green*256;
		
		wks = Integer.toString(255+red,16);
		if (wks.length()==1) wks = "0" + wks;
		outs = wks;
		wks = Integer.toString(255+green,16);
		if (wks.length()==1) wks = "0" + wks;
		outs = outs + wks;
		wks = Integer.toString(255+blue,16);
		if (wks.length()==1) wks = "0" + wks;
		outs = outs + wks;
		
		g.clearRect(0, mainy+mainh+cy*3, size().width, 35);
		g.setColor(Color.black);
		g.drawString("Color value = " + outs.toUpperCase(), mainx+5, mainy+mainh+cy*3+25);
	}
	
	
	public boolean mouseUp(java.awt.Event evt, int jx, int jy) {
		int	dt=1;
		
		if ((jx >= satx-dt)&&(jx <= satx+satw+dt)&&(jy >= saty-dt)&&(jy <= saty+sath+dt)) {
			bValue = (double)(jy - saty)/(double)sath;
			hValue = (double)(px - mainx)/(double)mainw;
			sValue = (double)(py - mainy)/(double)mainh;
			if(bValue<0) bValue=0;
			if(bValue>1) bValue=1;
			repaint();
			sy = jy;
		}
		if ((jx >= mainx-dt)&&(jx <= mainx+mainw+dt)&&(jy >= mainy-dt)&&(jy <= mainy+mainh+dt)) {
			repaint(px-4, py-4, 8, 8);
			px = jx ; py = jy;
			hValue = (double)(jx - mainx)/(double)mainw;
			sValue = (double)(jy - mainy)/(double)mainh;
			if(hValue<0) hValue=0;
			if(hValue>0.999) hValue=0.999;
			if(sValue<0) sValue=0;
			if(sValue>0.995) sValue=0.995;
			paintAns(getGraphics());
		}
		return(true);
	}
	
	
	public boolean mouseDrag(java.awt.Event evt, int jx, int jy) {
		int	dt=1;
		
		if ((jx >= satx-dt)&&(jx <= satx+satw+dt)&&(jy >= saty-dt)&&(jy <= saty+sath+dt)) {
			bValue = (double)(jy - saty)/(double)sath;
			hValue = (double)(px - mainx)/(double)mainw;
			sValue = (double)(py - mainy)/(double)mainh;
		} else {
			if ((jx >= mainx-dt)&&(jx <= mainx+mainw+dt)&&(jy >= mainy-dt)&&(jy <= mainy+mainh+dt)) {
				bValue = (double)(sy - saty)/(double)sath;
				hValue = (double)(jx - mainx)/(double)mainw;
				sValue = (double)(jy - mainy)/(double)mainh;
			} else {
				bValue = (double)(sy - saty)/(double)sath;
				hValue = (double)(px - mainx)/(double)mainw;
				sValue = (double)(py - mainy)/(double)mainh;
			}
		}
		if(bValue<0) bValue=0;
		if(bValue>1) bValue=1;
		if(hValue<0) hValue=0;
		if(hValue>0.999) hValue=0.999;
		if(sValue<0) sValue=0;
		if(sValue>0.995) sValue=0.995;
		paintValue(getGraphics());
		return(true);
	}
	
	
	public void update(Graphics g) {
		paint(g);
	}

}
